// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#include "../inc/sensor.hpp"



sensor::sensor( sc_core::sc_module_name name_ ) :
    sc_core::sc_module( name_ ),
    pclk("pclk"),
    presetn("presetn"),
    paddr("paddr"),
    psel("psel"),
    penable("penable"),
    pwrite("pwrite"),
    pwdata("pwdata"),
    pready("pready"),
    prdata("prdata"),
    sensor_high("sensor_high"),
    sensor_low("sensor_low"),
    prdata_var_1(0UL)
{
    pready.initialize( false );
    prdata.initialize( 0UL );

    SC_METHOD( process );
    sensitive << pclk.pos();
}

sensor::~sensor()
{}

void sensor::process()
{
    prdata_var_1 = prdata.read();
    if (penable.read())
    {
        prdata_var_1 = sensor_high.read() ? prdata_var_1 | uint32_t(1UL) : prdata_var_1
             & uint32_t(4294967294UL);
        prdata_var_1 = prdata_var_1 & 4294967041UL;
        prdata_var_1 = sensor_low.read() ? prdata_var_1 | uint32_t(256UL) : prdata_var_1
             & uint32_t(4294967039UL);
        prdata_var_1 = prdata_var_1 & 4294902271UL;
        prdata_var_1 = prdata_var_1 & 65535UL;
        pready = true;
    }
    else
    {
        prdata_var_1 = 0UL;
        pready = false;
    }
    prdata = prdata_var_1;
}



